﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using AsReaderGUN251G;
using AsBridge_SDK;

namespace AsReaderGUN251GDemo
{
    class Device
    {
        private static AsReader asreader = AsReader.SharedAsReader();
        private static AsReaderDelegate sharedAsReader = new AsReaderDelegate();
        private static bool isConnected = false;
        //public static bool isDisConnected = true;
        public delegate void ReceiveResultBarcodeScan(string barcodeType, string codeId, byte[] barcodeByte);
        public static ReceiveResultBarcodeScan receiveResultBarcodeScan = null;

        public delegate void ReceiveResultInventory(string tag);
        public static ReceiveResultInventory receiveResultInventory = null;

        public delegate void ReceiveChangedActionState(AsPacket.CommandType commandType, int resultCode);
        public static ReceiveChangedActionState receiveChangedActionState = null;

        public delegate Boolean ReceiveOnAsReaderTriggerKeyEvent(Boolean status);
        public static ReceiveOnAsReaderTriggerKeyEvent receiveOnAsReaderTriggerKeyEvent = null;

        public delegate void ReceiveUpdateDeviceState(AsPacket.ResultCode resultCode);
        public static ReceiveUpdateDeviceState receiveUpdateDeviceState = null;

        public static Dictionary<string, ReceiveBarcodeData> barcodeDataArrTmp = new Dictionary<string, ReceiveBarcodeData>();
        public static Dictionary<string, ReceiveInventoryData> inventoryDataArrTmp = new Dictionary<string, ReceiveInventoryData>();
        public static List<SelectionMaskItemData> selectionMaskItemArrTmp = new List<SelectionMaskItemData>();
        public static List<EPCMaskItemData> epcMaskItemArrTmp = new List<EPCMaskItemData>();
        public static string isPageReturn = "NO";
        public static string selectPortName = null;
        public static BluetoothDevice selectBluetoothInfo = new BluetoothDevice();
        //AsBridge设备连接状态（0：未连接 1：连接中 2：已连接 3.断开中）
        public static int bluetoothConnectedStatus = 0;
        public static bool isBluetoothConnected = false;
        private static AsBridgeDevice bluetoothDevice = null;
        public static string connectedDeviceName = null;

        public static Dictionary<string, BluetoothDevice> DeviceList = new Dictionary<string, BluetoothDevice>();

        public delegate void ReceiveAsBridgeIsConnected(bool isAsBridgeConnected);
        public static ReceiveAsBridgeIsConnected receiveAsBridgeIsConnected = null;

        public delegate void WhenReceivedAsBridgeFirmWareVersion(string firmWareVersion);
        public static WhenReceivedAsBridgeFirmWareVersion whenReceivedAsBridgeFirmWareVersion = null;

        public delegate void WhenReceivedAsBridgeHardWareVersion(string hardWareVersion);
        public static WhenReceivedAsBridgeHardWareVersion whenReceivedAsBridgeHardWareVersion = null;

        public delegate void WhenReceivedAsBridgeSerialNumber(string serialNumber);
        public static WhenReceivedAsBridgeSerialNumber whenReceivedAsBridgeSerialNumber = null;

        public delegate void WhenReceivedAsBridgeBattery(int battery);
        public static WhenReceivedAsBridgeBattery whenReceivedAsBridgeBattery = null;

        public delegate void ReceiveDeviceConnected(bool isDeviceConnected, string accessoryDeviceName);
        public static ReceiveDeviceConnected receiveDeviceConnected = null;

        public static bool GetisConnected()
        {
            return isConnected;
        }

        public static int ConnectWithPortName(string comPort)
        {
            asreader.SetAsreaderDelegate(sharedAsReader);
            sharedAsReader.updateDeviceState = (resultCode) =>
            {
                if (receiveUpdateDeviceState != null)
                {
                    receiveUpdateDeviceState(resultCode);
                }
            };
            USBDevice usbDevice = new USBDevice(comPort);
            int ret = asreader.Connect(usbDevice);
            if (ret == 1)
            {
                isConnected = true;
                //isDisConnected = false;
                SetDelegate();
            }
            else {
                isConnected = false;
                //isDisConnected = true;
            }

            return ret;
        }

        public static void ConnectWithBluetooth(BluetoothDevice selectBluetooth)
        {
            asreader.SetAsreaderDelegate(sharedAsReader);
            bluetoothDevice = new AsBridgeDevice(selectBluetooth);
            SetAsBridgeDelegate();
            int ret = asreader.Connect(bluetoothDevice);
            
        }
        public static void GetFirmwareVersion() {
            asreader.GetFirmwareVersion();
        }
        private static void SetAsBridgeDelegate() {
            sharedAsReader.asBridgeIsConnected = (bool isAsBridgeConnected) => {
                if (receiveAsBridgeIsConnected != null)
                {
                    receiveAsBridgeIsConnected(isAsBridgeConnected);//AsBridge设备连接状态（0：未连接 1：连接中 2：已连接 3.断开中）
                    isBluetoothConnected = isAsBridgeConnected;
                    bluetoothConnectedStatus = bluetoothDevice.AsBridgeConnStatus;
                    if (isAsBridgeConnected)
                    {
                        asreader.GetFirmwareVersion();
                    }
                    else {
                        isConnected = false;
                        ClearAsBridgeDelegate();
                    }
                }
            };
            sharedAsReader.whenReceivedAsBridgeFirmWareVersion = (string firmWareVersion) => {
                if (whenReceivedAsBridgeFirmWareVersion != null)
                {
                    whenReceivedAsBridgeFirmWareVersion(firmWareVersion);
                    asreader.GetHardwareVersion();
                }
            };
            sharedAsReader.whenReceivedAsBridgeHardWareVersion = (string hardWareVersion) => {
                if (whenReceivedAsBridgeHardWareVersion != null)
                {
                    whenReceivedAsBridgeHardWareVersion(hardWareVersion);
                    asreader.GetSerialNumber();
                }
            };
            sharedAsReader.whenReceivedAsBridgeSerialNumber = (string serialNumber) => {
                if (whenReceivedAsBridgeSerialNumber != null)
                {
                    whenReceivedAsBridgeSerialNumber(serialNumber);
                    asreader.GetAsBridgeBattery();
                }
            };
            sharedAsReader.whenReceivedAsBridgeBattery = (int battery) => {
                if (whenReceivedAsBridgeBattery != null)
                {
                    whenReceivedAsBridgeBattery(battery);
                }
            };
            sharedAsReader.deviceConnected = (bool isDeviceConnected, string accessoryDeviceName) => {
                if (receiveDeviceConnected != null)
                {
                    isConnected = isDeviceConnected;
                    if (isConnected)
                    {
                        connectedDeviceName = accessoryDeviceName;
                        SetDelegate();
                    }
                    else {
                        connectedDeviceName = null;
                    }
                    receiveDeviceConnected(isDeviceConnected, accessoryDeviceName);
                }
            };
        }
        private static void ClearAsBridgeDelegate()
        {
            sharedAsReader.asBridgeIsConnected = null;
            sharedAsReader.whenReceivedAsBridgeFirmWareVersion = null;
            sharedAsReader.whenReceivedAsBridgeHardWareVersion = null;
            sharedAsReader.whenReceivedAsBridgeSerialNumber = null;
            sharedAsReader.whenReceivedAsBridgeBattery = null;
            sharedAsReader.deviceConnected = null;
        }

        private static void SetDelegate()
        {
            sharedAsReader.detectBarcode = (barcodeType, codeId, barcodeByte) => {
                if (receiveResultBarcodeScan != null) { 
                    receiveResultBarcodeScan(asreader.GetBarcodeString(barcodeType), codeId, barcodeByte);
                }
            };
            sharedAsReader.changedActionState = (commandType, resultCode) =>
            {
                if (receiveChangedActionState != null) {
                    receiveChangedActionState(commandType, resultCode);
                }
            };

            sharedAsReader.onAsReaderTriggerKeyEvent = (commandType) =>
            {
                if (receiveOnAsReaderTriggerKeyEvent == null)
                {
                    return false;
                }
                else { 
                    return receiveOnAsReaderTriggerKeyEvent(commandType);
                }
                
            };

            sharedAsReader.readTag = (tag) =>
            {
                if (receiveResultInventory != null) {
                    receiveResultInventory(tag);
                }
            };

        }

        public static int Disconnect()
        {
            int ret = asreader.Disconnect();
            if (ret == 1)
            {
                isConnected = false;
            }
            return ret;
        }

        public static AsPacket.ResultCode StartDecode() {
            AsPacket.ResultCode resultCode = asreader.StartDecode();
            return resultCode;
        }

        public static AsPacket.ResultCode StopDecode()
        {
            AsPacket.ResultCode resultCode = asreader.StopDecode();
            return resultCode;

        }

        public static AsPacket.ResultCode Inventory() {
            AsPacket.ResultCode resultCode = asreader.Inventory();
            return resultCode;
        }
        public static AsPacket.ResultCode Stop()
        {
            AsPacket.ResultCode resultCode = asreader.Stop();
            return resultCode;
        }
        public static void SetContinuousMoude(bool isContinuous) {
            asreader.SetContinuousMoude(isContinuous);
        }
        public static void SetMaskType(AsPacket.MaskType maskType)
        {
            asreader.SetMaskType(maskType);
        }
        public static void ClearSelectionMask()
        {
            asreader.ClearSelectionMask();
        }

        public static void SetSelectionMask(AsSelectMaskParam asSelectParam)
        {
            asreader.SetSelectionMask(asSelectParam);
        }
        public static void SetUseSelectionMask(AsPacket.SelectFlag selectFlag)
        {
            asreader.SetUseSelectionMask(selectFlag);
        }

        public static void ClearEPCMask()
        {
            asreader.ClearEPCMask();
        }

        public static void AddEPCMask(AsSelectMaskEPCParam asEpcParam)
        {
            asreader.AddEPCMask(asEpcParam);
        }
        public static void SetEpcMaskMatchMode(bool enabled)
        {
            asreader.SetEpcMaskMatchMode(enabled);
        }

        public static void RemoveSelectionMask(int index) {
            asreader.RemoveSelectionMask(index);
        }

        public static void SetInventorySession(AsPacket.SessionType session)
        {
            asreader.SetInventorySession(session);
        }

        public static void SetSessionFlag(AsPacket.SessionFlag sessionFlag) {
            asreader.SetSessionFlag(sessionFlag);
        }
        public static string GetSDKVersion()
        {
            return asreader.GetSDKVersion();
        }

        public static void SetSelectionMaskItem(List<SelectionMaskItemData> selectionMaskItemArr, int selectFlagIndex,
               int inventorySessionIndex, int sessionFlagIndex) {
            AsSelectMaskParam asSelectParam;
            for (int i = 0; i < 8; i++)
            {
                if (i < selectionMaskItemArr.Count)
                {
                    asSelectParam = new AsSelectMaskParam()
                    {
                        Index = i,
                        Offset = selectionMaskItemArr[i].Offset,
                        Length = selectionMaskItemArr[i].Length,
                        Mask = selectionMaskItemArr[i].Mask,
                        Target = selectionMaskItemArr[i].Target,
                        Action = selectionMaskItemArr[i].Action,
                        Bank = selectionMaskItemArr[i].Bank,
                        Used = true,
                    };
                    Device.SetSelectionMask(asSelectParam);
                }
                else
                {
                    Device.RemoveSelectionMask(i);
                }
            }

            if (selectionMaskItemArr.Count > 0)
            {
                Device.SetUseSelectionMask((AsPacket.SelectFlag)selectFlagIndex);
            }
            else
            {
                Device.ClearSelectionMask();
            }

            Device.SetInventorySession((AsPacket.SessionType)inventorySessionIndex);
            Device.SetSessionFlag((AsPacket.SessionFlag)sessionFlagIndex);
        }

        public static void SetEPCMaskItem(List<EPCMaskItemData> epcMaskItemArr, bool isCheckedStatus)
        {
            Device.ClearEPCMask();
            if (epcMaskItemArr.Count > 0)
            {
                AsSelectMaskEPCParam asEpcParam;
                for (int i = 0; i < epcMaskItemArr.Count; i++)
                {
                    asEpcParam = new AsSelectMaskEPCParam()
                    {
                        Offset = epcMaskItemArr[i].Offset,
                        Length = epcMaskItemArr[i].Length,
                        Mask = epcMaskItemArr[i].Mask,
                    };
                    Device.AddEPCMask(asEpcParam);
                }
            }

            Device.SetEpcMaskMatchMode(isCheckedStatus);
        }

    }
}
